import { __assign } from './../external/tslib/tslib.es6.js';
import React, { useRef, useEffect } from 'react';
import useEventListener from './../external/@use-it/event-listener/dist/event-listener.m.js';
import { GroupedPortal } from '@highlight-ui/utils-portal-manager';
import noop from 'lodash/noop';
import invoke from 'lodash/invoke';
import classnames from 'classnames';
import { parseMetadata } from '@highlight-ui/utils-commons';
import styles from './Modal.module.scss.js';
import { useFocusTrap } from './../external/@mantine/hooks/esm/use-focus-trap/use-focus-trap.js';

var Modal = function (_a) {
  var metadata = _a.metadata,
      children = _a.children,
      className = _a.className,
      onRequestToClose = _a.onRequestToClose,
      _b = _a.onClose,
      onClose = _b === void 0 ? noop : _b,
      _c = _a.onOpen,
      onOpen = _c === void 0 ? noop : _c,
      open = _a.open;
  var ref = useFocusTrap();
  var firstRender = useRef(true);
  useEventListener('keydown', function (event) {
    if (open && event.key === 'Escape') onRequestToClose();
  }, window);
  useEffect(function () {
    if (firstRender.current) {
      firstRender.current = false;
      if (!open) return;
    }

    if (open) {
      onOpen();
      invoke(document, 'body.classList.add', styles.scrollLocked);
    } else {
      onClose();
      invoke(document, 'body.classList.remove', styles.scrollLocked);
    } // eslint-disable-next-line consistent-return


    return function () {
      invoke(document, 'body.classList.remove', styles.scrollLocked);
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [open]);
  if (!open) return null;
  return /*#__PURE__*/React.createElement(GroupedPortal, null, /*#__PURE__*/React.createElement("div", __assign({}, parseMetadata(metadata), {
    className: styles.modal,
    ref: ref
  }), /*#__PURE__*/React.createElement("div", {
    className: styles.modalBackdrop
  }), /*#__PURE__*/React.createElement("div", {
    className: classnames(styles.modalContent, className)
  }, children)));
};

export { Modal as default };
//# sourceMappingURL=Modal.js.map
